clear
clc
% Este programa ser utilizado para llevar a cabo la optimiacin de
% dimensiones de la platorma segn el procedimiento descrito en la redccin
% del proyecto. En este caso se simularn distintos valores de posibles
% dimensiones para una plataforma de 4 columnas. 
% Todas los valores vienen dados en el sistema internacional  IS, m ,kg, Tn, m^3, m^4.

% Variables fijas:
L=94;
B=73;
h=3;
hc=10;
steel=7850;
thick=0.02;
d=B/4;
        % Cargas variables.
        Agua_perforacion=615;
        Agua_potable=300;
        Diesel=585;
        Salmuera=239.72;
        Aceite_base=176;
        lodo=920;
        lodo_granel=368;
        cemento=480;
        sacos=12;
        
        BOP=10.54;
        Desviador=10;
        Tensores=56.8;
        Manifold=10.185;
        fondeo=1124;
        helicoptero=6.4;
        VL=4913.645;
        
%Equipos fijos
Torre_perforacion=240;
Draworks=86.5;
compensador=163;
mesa_rotatoria=10.5;
bombas_lodo=45;
motores=110;
top_drive=15;
manejo_tuberias=17;
habilitacion=100;
helipuerto=180;
Gruas=50+40+24.8;
Equipm=1081.8;
Agualastre=10000;

%% Comienzo de la simulacin.
for i=1:200
    if i==1
        lp_4(i)=50;
    else
        lp_4(i)=lp_4(i-1)+((130-50)/200);
    end 
    hp(i)=lp_4(i)*0.1;
    bp(i)=lp_4(i)*0.2;
    H(i)=hc+hp(i)+2*h;   
    for j=1:200
        if j==1
            b_4(i,j)=2;
        else
            b_4(i,j)=b_4(i,j-1)+((bp(i)-2)/200);
        end
        % Peso estructural:
        
        deck1=(((L*B*2)+(L*h*2)+(B*h*2))*thick*steel)/1000;
        deck2=(((L*B)+(L*h*2)+(B*h*2))*thick*steel)/1000;
        columns_w=(4*b_4(i,j)*thick*4*hc*steel*2)/1000;
        pontoons_w=((0.8*lp_4(i)*hp(i)*2)+(0.8*lp_4(i)*bp(i)*2)+((2/3)*0.1*lp_4(i)*bp(i)*4)+(bp(i)*hp(i)*2))*2*2*thick*steel/1000;
        
        Struct_weight_4(i,j)=(deck1+deck2+columns_w+pontoons_w);
       
        Weight(i,j)=Struct_weight_4(i,j)+VL+Equipm+Agualastre;
        
        % Tc / Despl-Weigth=0
        
        Volume_pontoon=(0.8*lp_4(i)*hp(i)*bp(i)+0.1*lp_4(i)*bp(i)*hp(i)*(2/3)*2)*2;
        
        Tc_4(i,j)=(Weight(i,j)-Volume_pontoon*1.025)/(1.025*(b_4(i,j)^2)*4);
        
        T_4(i,j)=Tc_4(i,j)+hp(i);
        
        Airgap_4(i,j)=H(i)-2*h-T_4(i,j);
        
        if Airgap_4(i,j)>=17 
            
            KG_4(i,j)=(columns_w*((hc/2)+hp(i))+deck1*(H(i)-(h/2))+deck2*(H(i)-(3*h/2))+pontoons_w*(hp(i)/2)+...
            lodo*(hp(i)*0.5)...
            +Aceite_base*(hp(i)*0.5)...
            +Salmuera*(hp(i)*0.5)...
            +Agua_perforacion*(hp(i)+(3/8)*hc)...
            +Agua_potable*(hp(i)*0.5)...
            +lodo_granel*(hp(i)*0.5)...
            +sacos*(H(i)-2*h)...
            +Diesel*(hp(i)+(1/8)*hc)...
            +cemento*(hp(i)*0.5)...
            +Draworks*H(i)...
            +compensador*H(i)...
            +mesa_rotatoria*H(i)...
            +top_drive*H(i)...
            +manejo_tuberias*H(i)...
            +bombas_lodo*(H(i)-2*h)...
            +Torre_perforacion*(H(i)-2*h+24)...
            +motores*(H(i)-2*h)...
            +Desviador*(hc+hp(i)+h)...
            +BOP*(hc+hp(i)+h)...
            +Manifold*(hc+hp(i)+h)...
            +Tensores*(hc+hp(i)+h)...
            +fondeo*(H(i)-2*h)...
            +habilitacion*(H(i)+1)...
            +helipuerto*(H(i)+2)...
            +helicoptero*(H(i)+2)...
            +Gruas*(H(i)+1)...
            +Agualastre*(hp(i)+(hc/8))...
         )/Weight(i,j);
            
            Iw(i,j)=(b_4(i,j)^2)*4*(d^2);
            
            Volume(i,j)=((b_4(i,j)^2)*4*Tc_4(i,j))+(0.8*lp_4(i)*bp(i)*hp(i)+0.1*(2/3)*lp_4(i)*bp(i)*hp(i)*2)*2;
            
            Equi_4(i,j)=(Volume(i,j)*1.025)-Weight(i,j);
           
            KB_4(i,j)=(((b_4(i,j)^2)*4*Tc_4(i,j)*((Tc_4(i,j)/2)+hp(i)))+((0.8*lp_4(i)*bp(i)*hp(i)+0.1*(2/3)*lp_4(i)*bp(i)*hp(i)*2)*2*(hp(i)/2)))/Volume(i,j);
            
            GM_4(i,j)=KB_4(i,j)+(Iw(i,j)/Volume(i,j))-KG_4(i,j);
            
        else
            GM_4(i,j)=0;
        end
    end
  

end

%% Se almacenan los valores que cumplan con los tres requisitos
l=1;
h=1;
for i=1:200
    
    for j=1:200
        
        if GM_4(i,j)>=0.3 && Struct_weight_4(i,j)>=6000 && Struct_weight_4(i,j)<=9000 && T_4(i,j)>=(hp(i)+1)
           GM_valid_4(l,h)=GM_4(i,j);
           GM_valid_4(l+1,h)=lp_4(i);
           GM_valid_4(l+2,h)=b_4(i,j);
           GM_valid_4(l+3,h)=T_4(i,j);
           GM_valid_4(l+4,h)=KG_4(i,j);
           GM_valid_4(l+5,h)=KB_4(i,j);
           GM_valid_4(l+6,h)=Struct_weight_4(i,j);
           GM_valid_4(l+7,h)=Weight(i,j);
           h=h+1;
        end
    end

    
end
[max posicion]=max(GM_valid_4(1,:));

GM_4_max=GM_valid_4(:,posicion)

        
        
        
        
        














